#include <SPI.h>
#include <Pixy2.h>

const int pinENA = 5;
const int pinIN1 = 6;
const int pinIN2 = 7;

const int pinENB = 10;
const int pinIN4 = 9;
const int pinIN3 = 8;

 int compensacion;

#define MAX_SPEED 255 // Velocidad máxima para los motores

Pixy2 pixy;
#define X_CENTER 160 // Valor central del eje X del campo de visión de la Pixy2

// Definición de los pines para el controlador L298N
void avanzar(int leftSpeed, int rightSpeed) {

    digitalWrite(pinIN2, HIGH);
  digitalWrite(pinIN1, LOW);
  analogWrite(pinENA, leftSpeed);

    digitalWrite(pinIN3, HIGH);
  digitalWrite(pinIN4, LOW);
  analogWrite(pinENB, rightSpeed);
}

void retroceder(int leftSpeed, int rightSpeed) {

    digitalWrite(pinIN2, LOW);
  digitalWrite(pinIN1, HIGH);
  analogWrite(pinENA, rightSpeed);

    digitalWrite(pinIN3, LOW);
  digitalWrite(pinIN4, HIGH);
  analogWrite(pinENB, leftSpeed);


}
void pivotar_iz(int leftSpeed, int rightSpeed) {

    digitalWrite(pinIN2, HIGH);
  digitalWrite(pinIN1, LOW);
  analogWrite(pinENA, leftSpeed);

    digitalWrite(pinIN3, LOW);
  digitalWrite(pinIN4, HIGH);
  analogWrite(pinENB, rightSpeed);
}

void pivotar_der(int leftSpeed, int rightSpeed) {

    digitalWrite(pinIN2, LOW);
  digitalWrite(pinIN1, HIGH);
  analogWrite(pinENA, leftSpeed);

    digitalWrite(pinIN3, HIGH);
  digitalWrite(pinIN4, LOW);
  analogWrite(pinENB, rightSpeed);
}
void girar_der(int leftSpeed, int rightSpeed) {

    digitalWrite(pinIN2, HIGH);
  digitalWrite(pinIN1, LOW);
  analogWrite(pinENA, leftSpeed);

    digitalWrite(pinIN3, HIGH);
  digitalWrite(pinIN4, LOW);
  analogWrite(pinENB, rightSpeed);
  analogWrite(pinENB, rightSpeed);
}
void girar_iz(int leftSpeed, int rightSpeed) {

    digitalWrite(pinIN2, HIGH);
  digitalWrite(pinIN1, LOW);
  analogWrite(pinENA, leftSpeed);

    digitalWrite(pinIN3, HIGH);
  digitalWrite(pinIN4, LOW);
  analogWrite(pinENB, rightSpeed);
}

void detener() {
  analogWrite(pinENA, 0);
  analogWrite(pinENB, 0);
}

void setup() {
  Serial.begin(115200);
  Serial.print("Starting...\n");

    pinMode(pinIN1, OUTPUT);
  pinMode(pinIN2, OUTPUT);
  pinMode(pinENA, OUTPUT);

  pinMode(pinIN3, OUTPUT);
  pinMode(pinIN4, OUTPUT);
  pinMode(pinENB, OUTPUT);

  detener(); // Asegurarse de que los motores estén detenidos al inicio

  pixy.init();
  pixy.setLamp(1, 1);
  pixy.changeProg("color_connected_components"); // Cambiar al programa de seguimiento de color
}

void loop() {
  int16_t blocks;
  int32_t error;

  blocks = pixy.ccc.getBlocks();
  
  if (blocks) {
    // Si se detecta al menos un bloque
    int16_t posX = pixy.ccc.blocks[0].m_x;
    Serial.print("Linea detectada");
    
    if (posX > 125 && posX < 175)
    {
      /* compensacion = map(posX, 100, 250, 0, 55); // mapea la posición de la linea roja entre 0 y 55 que son los valores de velocidad con los que vamos a jugar para corregir la posición del miniAGV
       if(posX> 150)
       {
        compensacion =-compensacion;
       }
      avanzar(200+ compensacion,200-compensacion);*/
      avanzar(200,200);
      delay(10);
            Serial.print("Linea centrada: ");
            Serial.println(posX);
    }
    else if (posX > 175) {
      // Si el objeto está más a la derecha, girar hacia la derecha
      //avanzar(0, 255); // Girar hacia la derecha
      avanzar(0,255);
      delay(10);
      Serial.print("Linea detectada a la derecha: ");
            Serial.println(posX);
    } 
    else if (posX < 125) {
      // Si el objeto está más a la izquierda, girar hacia la izquierda
      Serial.print("Linea detectada a la izquierda: ");
            Serial.println(posX);
     // avanzar(255, 0); // Girar hacia la izquierda
      avanzar(255,0);
      delay(10);
    } /*else {
      // Si el objeto está centrado, avanzar recto
      avanzar(MAX_SPEED, MAX_SPEED);
    }*/
  } else {
    // Si no se detectan bloques, detenerse
    detener();
  }
}
